
set( artdaq_database_VERSION 1.04.68 )
set( artdaq_database_UPS_VERSION v1_04_68 )


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was product-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################


## find_ups_product directives
## remember that these are minimum required versions
    find_ups_boost( v1_57_0 )
    find_ups_product( cetpkgsupport v1_11_00 )
    find_ups_product( mongodb v3_4_6 )


## find_library directives
      set( ARTDAQ-DATABASE_SHAREDCOMMON $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_SharedCommon.so )
      set( ARTDAQ-DATABASE_DATAFORMATS_JSON $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_DataFormats_Json.so )
      set( ARTDAQ-DATABASE_DATAFORMATS_FHICL $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_DataFormats_Fhicl.so )
      set( ARTDAQ-DATABASE_DATAFORMATS_XML $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_DataFormats_Xml.so )
      set( ARTDAQ-DATABASE_OVERLAY $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_Overlay.so )
      set( ARTDAQ-DATABASE_JSONDOCUMENT $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_JsonDocument.so )
      set( ARTDAQ-DATABASE_BASICTYPES $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_BasicTypes.so )
      set( ARTDAQ-DATABASE_STORAGEPROVIDERS $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_StorageProviders.so )
      set( ARTDAQ-DATABASE_STORAGEPROVIDERS_MONGODB $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_StorageProviders_MongoDB.so )
      set( ARTDAQ-DATABASE_STORAGEPROVIDERS_FILESYSTEMDB $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_StorageProviders_FileSystemDB.so )
      set( ARTDAQ-DATABASE_STORAGEPROVIDERS_UCONDB $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_StorageProviders_UconDB.so )
      set( ARTDAQ-DATABASE_CONFIGURATIONDB $ENV{ARTDAQ_DATABASE_LIB}/libartdaq-database_ConfigurationDB.so )
      include_directories ( $ENV{ARTDAQ_DATABASE_INC} )

check_required_components(artdaq_database)

